#!/usr/bin/python

from cPickle import *
import os
import sys
import Tkinter
import tkFileDialog
import tkMessageBox
from Tkconstants import *
#from tkSimpleDialog import *
from tkMessageBox import *

lang="E"
try:
	f=open(os.getcwd() +"/." +"mpgjoiner_init", "r")
	text=f.readlines()
	f.close()
	for i in text:
		if i[0:4] == "spr=":
			lang=i[4:5]
except:
	pass

if lang == "D":
	title_neuer_dateiname="Neuer Dateiname"
	error="Fehler"
	dir_ein_not_exist="Pfad ein existiert nicht"
	dir_aus_not_exist="Pfad aus existiert nicht"
	directories="Verzeichnisse"
	standard_directory_in="Standardverzeichnis Eingabedateien:"
	standard_directory_out="Standardverzeichnis Ausgabedateien:"
	preferences="Einstellungen"
	help="Hilfe"
	pref_directories="Verzeichnisse ..."
	language="Sprache"
	select_files="Dateien selektieren"
	documentation="Bedienungsanleitung"
	help_text="Nach Start des Programms \xfcber Einstellungen -> Verzeichnisse die Standardverzeichnisse f\xfcr die Ein- und Ausgabedateien festlegen.\n\n In Einstellungen -> Sprache kann die Sprache des Programms auf Deutsch oder Englisch eingestellt werden. Standardm\xe4\xdfig ist die Sprache auf Englisch eingestellt. Wenn die Sprache ge\xe4ndert wird, ist ein Neustart des Programms erforderlich.\n\nJetzt die Dateien selektieren.\n\n Anschlie\xdfend \xf6ffnet sich ein Pop-up, in dem der neue Dateiname eingegeben werden muss. Vorbelegt ist hier der Dateiname der ersten MPG-Datei; wenn dieser Dateiname nicht ge\xe4ndert wird, wird diese Datei \xfcberschrieben.\n\n Dann auf OK klicken."
	caution="Achtung!"
	question="Die Ausgabedatei existiert schon. Wollen Sie diese wirklich \xfcberschreiben?"
else:
	title_neuer_dateiname="New filename"
	error="Error"
	dir_ein_not_exist="Path input does not exist"
	dir_aus_not_exist="Path output does not exist"
	directories="Directories"
	standard_directory_in="Standarddirectory infiles:"
	standard_directory_out="Standarddirectory outfiles:"
	preferences="Preferences"
	help="Help"
	pref_directories="Directories ..."
	language="Language"
	select_files="Select files"
	documentation="Operations instruction"
	help_text="When program is startet, go to preferences -> directories and enter the standard-directories for input- and outputfiles.\n\n In preferences -> language you can modify the language. Default is english. If you change the language, you must restart the program.\n\nNow select your files.\n\n A popup will open, where you must enter the new filename. Default is the first filename of your mpg-files. If you don't change this filename, this file will be replaced.\n\n Now click on OK."
	caution="Caution!"
	question="Outputfile already exists. Do you want to overwrite it?"

def select(event=None):
	def join(event=None):
		top1=Tkinter.Toplevel()
		frame1=Tkinter.Frame(top1)
		frame1.pack()
		canvas=Tkinter.Canvas(frame1, width=200, height=20, bg="white")
		canvas.pack()
		start=len(dateien) 
		root.config(cursor="watch")
		canvas.config(cursor="watch")
		canvas.update_idletasks()
		k=-1
		for i in range (len(dateien)):
			k+=1
			if i == 0:
				zugriff = 'w'
				neue_datei = entry.get()
				if os.path.exists(neue_datei):
					if not tkMessageBox.askyesno(caution, question):
						top1.destroy()
						return
				top.destroy()
				root.update_idletasks()
			else:
				zugriff = 'a'
			datei = file(dateien[i], 'r')
			mpg=datei.read()
			datei.close()
			mpg_gesamt = file(dateiname.get(), zugriff)
			mpg_gesamt.write(mpg)
			start=k*200/len(dateien)
			ende=(k+1)*200/len(dateien)
			canvas.create_rectangle(start, 0, ende, 20, fill="black")
			canvas.update_idletasks()
		top1.destroy()
		root.config(cursor="left_ptr")

	f=open(os.getcwd() +"/." +"mpgjoiner_init", "r")
	text=f.readlines()
	f.close()
	for i in text:
		if i[0:4] == "ein=":
			verz_ein=i[4:]
		elif i[0:4] == "aus=":
			verz_aus=i[4:]
	dateien=tkFileDialog.askopenfilenames(initialdir=verz_ein.rstrip())
	dateiname = Tkinter.StringVar()
	top=Tkinter.Toplevel()
	top.title(title_neuer_dateiname)
	frame = Tkinter.Frame(top)
	frame.pack()
	entry = Tkinter.Entry(frame, textvariable=dateiname, width=100, bg="white")
	entry.pack(side=LEFT)
	if len(dateien) > 0:
		entry.insert(0, dateien[0])
		cursor = dateien[0].rfind(".")
		entry.focus_set()
		entry.icursor(cursor)
		entry.bind('<KeyPress-Return>', join)
		entry.bind('<KeyPress-KP_Enter>', join)
		button = Tkinter.Button(frame, text="OK", command=join)
		button.pack(side=RIGHT)
	else:
		top.destroy()

def verzeichnisse():
	def verzeichnisse_speichern():
		text=[]
		ein_gesetzt = 0
		aus_gesetzt = 0
		if not os.path.exists(entry_ein.get()):
			showerror(error, dir_ein_not_exist)
			return
		if not os.path.exists(entry_aus.get()):
			showerror(error, dir_aus_not_exist)
			return
		try:
			f=open(os.getcwd() +"/." +"mpgjoiner_init", "r")
			text=f.readlines()
			f.close()
			k=-1
			for i in text:
				k+=1
				if i[0:4] == "ein=":
					text[k] = "ein=" +entry_ein.get() +"\n"
					ein_gesetzt = 1
				elif i[0:4] == "aus=":
					text[k] = "aus=" +entry_aus.get() +"\n"
					aus_gesetzt = 1
			if ein_gesetzt == 0:
				text.append("ein=" +entry_ein.get() +"\n")
			if aus_gesetzt == 0:
				text.append("aus=" +entry_ein.get() +"\n")
			f=open(os.getcwd() +"/." +"mpgjoiner_init", "w")
			f.writelines(text)
			f.close()
		except:
			f=open(os.getcwd() +"/." +"mpgjoiner_init", "w")
			text.append("ein=" +entry_ein.get() +"\n")
			text.append("aus=" +entry_aus.get() +"\n")
			f.writelines(text)
			f.close()
		top.destroy()
		
	top=Tkinter.Toplevel()
	top.title(directories)
	frame = Tkinter.Frame(top)
	frame.pack()
	label=Tkinter.Label(frame, text=standard_directory_in)
	label.pack(anchor=W)
	verzeichnis_ein=Tkinter.StringVar()
	entry_ein=Tkinter.Entry(frame, textvariable=verzeichnis_ein, width=100, bg="white")
	entry_ein.pack(side=TOP)
	entry_ein.focus_set()
	label=Tkinter.Label(frame, text=standard_directory_out)
	label.pack(anchor=W)
	verzeichnis_aus=Tkinter.StringVar()
	entry_aus=Tkinter.Entry(frame, textvariable=verzeichnis_aus, width=100, bg="white")
	entry_aus.pack(side=TOP)
	try:
		f=open(os.getcwd() +"/." +"mpgjoiner_init", "r")
		text=f.readlines()
		for i in text:
			if i[0:4] == "ein=":
				entry_ein.insert(0, i.rstrip()[4:])
			elif i[0:4] == "aus=":
				entry_aus.insert(0, i.rstrip()[4:])
		f.close()
	except:
		entry_ein.insert(0, "")
		entry_aus.insert(0, "")
	button=Tkinter.Button(frame, text="OK", command=verzeichnisse_speichern)
	button.pack()
	
def sprache(sprachevar):
	text=[]
	spr_gesetzt = 0
	try:
		f=open(os.getcwd() +"/." +"mpgjoiner_init", "r")
		text=f.readlines()
		f.close()
		f=open(os.getcwd() +"/." +"mpgjoiner_init", "w")
		k=-1
		for i in text:
			k+=1
			if i[0:4] == "spr=":
				text[k] = "spr=" +sprachevar.get() +"\n"
				spr_gesetzt = 1
		if spr_gesetzt == 0:
			text.append("spr=" +sprachevar.get() +"\n")
		f.writelines(text)
		f.close()
	except:
		f=open(os.getcwd() +"/." +"mpgjoiner_init", "w")
		text.append("spr=" +sprachevar.get() +"\n")
		f.writelines(text)
		f.close()
		
def info():
	def ok():
		top.destroy()
		
	top=Tkinter.Toplevel(root)
	top.title("Info")
	frame=Tkinter.Frame(top, relief=RIDGE, borderwidth=2)
	frame.pack(fill=X)
	label=Tkinter.Label(frame, text="PyJoin Version 1.0\nHans-Werner May\n2005-07-01\nLicense: GPL")
	label.pack(padx=10, pady=10)
	button=Tkinter.Button(frame, text="OK", command=ok)
	button.pack()
	
def hilfe():
	def ok():
		top.destroy()
		
	top=Tkinter.Toplevel(root)
	top.title(help)
	frame=Tkinter.Frame(top, relief=RIDGE, borderwidth=2)
	frame.pack(fill=X)
	label=Tkinter.Label(frame, text=help_text, wraplength=300)
	label.pack(padx=10, pady=10)
	button=Tkinter.Button(frame, text="OK", command=ok)
	button.pack()
		
root=Tkinter.Tk()
root.title("PyJoin")
frame = Tkinter.Frame(root)
frame.pack(fill=BOTH, expand=1)

menu=Tkinter.Menu(root)
root.configure(menu=menu)
optionMenu=Tkinter.Menu(menu)
hilfeMenu=Tkinter.Menu(optionMenu)
spracheMenu=Tkinter.Menu(optionMenu)
menu.add_cascade(label=preferences, underline=0, menu=optionMenu)
menu.add_cascade(label=help, underline=0, menu=hilfeMenu)
optionMenu.add_command(label=pref_directories, command=verzeichnisse)
sprachevar=Tkinter.StringVar()
optionMenu.add_cascade(label=language, menu=spracheMenu)
spracheMenu.add_radiobutton(label="Deutsch", variable=sprachevar, value="D",  command=lambda:sprache(sprachevar))
spracheMenu.add_radiobutton(label="English", variable=sprachevar, value="E", command=lambda:sprache(sprachevar))
hilfeMenu.add_command(label="Info", command=info)
hilfeMenu.add_command(label=documentation, command=hilfe)

button=Tkinter.Button(frame, text=select_files, command=select)
button.pack(side=LEFT, padx=10, pady=10)
button.focus_set()

button=Tkinter.Button(frame, text="Exit", command=root.destroy)
button.pack(side=RIGHT, padx=10, pady=10)

root.mainloop()
